# Extremely lame sorted list class; lame because it only
# defines the list methods needed by the example code below
class SortedList(object):

  def __init__(self, source_list):
    self.sorted_list = sorted(list(source_list))

  def append(self, item):
    self.sorted_list.append(item)
    self.sorted_list = sorted(self.sorted_list)

  def __iter__(self):
    return self.sorted_list.__iter__()

# GrocerList delegates to an internal list object called items
class GroceryList(object):

  def __init__(self, items):
    self.items = items 

  def add_item(self, item):
    self.items.append(item)

  def print_items(self):
    for i, item in enumerate(self.items):
      print("{0}. {1}".format(i+1, item))

# we start by creating a grocery list that just uses python's default list
# object as the object that it delegates to.

my_list = GroceryList([])

# we add items

my_list.add_item("milk")
my_list.add_item("bread")
my_list.add_item("snickers")
my_list.add_item("fish")

# we print them out
print("")
print("Unsorted: ")
print("")
my_list.print_items()
print("")

# now we create a sorted list that contains our grocery list
# and we change our grocery list object to now delegate to this
# sorted list. And this shows that we can change delegation relationships
# at runtime

my_list.items = SortedList(my_list.items)

# lets add new items to our list
my_list.add_item("wine")
my_list.add_item("cheese")

# we print out the list again; this time the items appear in sorted order
print("")
print("Sorted: ")
print("")
my_list.print_items()
print("")
